<?php
/**
 * BannerReadonlyProperties
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\CmsClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi Cms.
 *
 * Управление контентом
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\CmsClient\Dto;

use \ArrayAccess;
use \Ensi\CmsClient\ObjectSerializer;

/**
 * BannerReadonlyProperties Class Doc Comment
 *
 * @category Class
 * @package  Ensi\CmsClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class BannerReadonlyProperties implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'BannerReadonlyProperties';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'desktop_image' => '\Ensi\CmsClient\Dto\File',
        'tablet_image' => '\Ensi\CmsClient\Dto\File',
        'mobile_image' => '\Ensi\CmsClient\Dto\File',
        'button_id' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'id' => null,
        'desktop_image' => null,
        'tablet_image' => null,
        'mobile_image' => null,
        'button_id' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'id' => false,
        'desktop_image' => false,
        'tablet_image' => false,
        'mobile_image' => false,
        'button_id' => true
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::$openAPINullables[$property])) {
            return self::$openAPINullables[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'desktop_image' => 'desktop_image',
        'tablet_image' => 'tablet_image',
        'mobile_image' => 'mobile_image',
        'button_id' => 'button_id'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'desktop_image' => 'setDesktopImage',
        'tablet_image' => 'setTabletImage',
        'mobile_image' => 'setMobileImage',
        'button_id' => 'setButtonId'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'desktop_image' => 'getDesktopImage',
        'tablet_image' => 'getTabletImage',
        'mobile_image' => 'getMobileImage',
        'button_id' => 'getButtonId'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('id', $data, null);
        $this->setIfExists('desktop_image', $data, null);
        $this->setIfExists('tablet_image', $data, null);
        $this->setIfExists('mobile_image', $data, null);
        $this->setIfExists('button_id', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id Идентификатор
     *
     * @return $this
     */
    public function setId($id)
    {


        /*if (is_null($id)) {
            throw new \InvalidArgumentException('non-nullable id cannot be null');
        }*/
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets desktop_image
     *
     * @return \Ensi\CmsClient\Dto\File|null
     */
    public function getDesktopImage()
    {
        return $this->container['desktop_image'];
    }

    /**
     * Sets desktop_image
     *
     * @param \Ensi\CmsClient\Dto\File|null $desktop_image desktop_image
     *
     * @return $this
     */
    public function setDesktopImage($desktop_image)
    {


        /*if (is_null($desktop_image)) {
            throw new \InvalidArgumentException('non-nullable desktop_image cannot be null');
        }*/
        $this->container['desktop_image'] = $desktop_image;

        return $this;
    }

    /**
     * Gets tablet_image
     *
     * @return \Ensi\CmsClient\Dto\File|null
     */
    public function getTabletImage()
    {
        return $this->container['tablet_image'];
    }

    /**
     * Sets tablet_image
     *
     * @param \Ensi\CmsClient\Dto\File|null $tablet_image tablet_image
     *
     * @return $this
     */
    public function setTabletImage($tablet_image)
    {


        /*if (is_null($tablet_image)) {
            throw new \InvalidArgumentException('non-nullable tablet_image cannot be null');
        }*/
        $this->container['tablet_image'] = $tablet_image;

        return $this;
    }

    /**
     * Gets mobile_image
     *
     * @return \Ensi\CmsClient\Dto\File|null
     */
    public function getMobileImage()
    {
        return $this->container['mobile_image'];
    }

    /**
     * Sets mobile_image
     *
     * @param \Ensi\CmsClient\Dto\File|null $mobile_image mobile_image
     *
     * @return $this
     */
    public function setMobileImage($mobile_image)
    {


        /*if (is_null($mobile_image)) {
            throw new \InvalidArgumentException('non-nullable mobile_image cannot be null');
        }*/
        $this->container['mobile_image'] = $mobile_image;

        return $this;
    }

    /**
     * Gets button_id
     *
     * @return int|null
     */
    public function getButtonId()
    {
        return $this->container['button_id'];
    }

    /**
     * Sets button_id
     *
     * @param int|null $button_id Идентификатор кнопки
     *
     * @return $this
     */
    public function setButtonId($button_id)
    {

        if (is_null($button_id)) {
            array_push($this->openAPINullablesSetToNull, 'button_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('button_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['button_id'] = $button_id;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


